@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program demonstrates the use of the WORKAREA function to  *
'* call a non BAX program as an external BAX sub-routine and to   *
'* retrieve up to 128 characters of information from the called   *
'* program.  The called program in this example is FPCALC.EXE     *
'* which is written in POWER BASIC, although any language could   *
'* be used as long as it has the capability of writing to a       *
'* specific segment and address in the PC's conventional memory.  *
'* The source code for FPCALC is contained in the file FPCALC.BAS *
'* although to modify it and re-compile it would require that you *
'* have the POWER BASIC compiler installed on your system.        *
'* It would be possible without a lot of effort to convert FPCALC *
'* to QUICK BASIC, VBDOS or PDS if you have one of those          *
'* compilers available.                                           *
'*                                                                *
'* FPCALC.EXE allows you to add at least some floating point      *
'* calculation capability to your BAX programs.  Personally, I    *
'* have never found a need for floating point calculations in a   *
'* BAX program but I'm sure that there will come a time when it   *
'* might be handy to make a few calculations.  I would avoid      *
'* calling FPCALC from inside a loop since it has to be loaded    *
'* from disk each time it is executed and as a result, a program  *
'* which does this is going to be unbearably slow.                *
'*                                                                *
'* FPCALC.EXE accepts arguments in groups of 3.  Each group       *
'* consists of:                                                   *
'* 1) A single character operation code indicating the type of    *
'*    mathematical operation to be performed using the two values *
'*    which follow it.                                            *
'* 2) A numeric value to be used in a calculation                 *
'* 3) A numeric value to be used in a calculation                 *
'*                                                                *
'* Operation codes are: A -- addition                             *
'*                      B -- subtraction                          *
'*                      M -- multipication                        *
'*                      D -- division                             *
'*                      E -- exponentiation                       *
'*                                                                *
'* For example, if you wanted to divide 23.44 by 6.72 the group   *
'* would be:        D 23.44 6.72                                  *
'*                                                                *
'* Operation codes always appear as items 1 , 4 , 7 , 10 , etc in *
'* the command line supplied to FPCALC.EXE.  The last item on the *
'* command line must be the BAX work area segment address, which  *
'* is the value returned by the WORKAREA function.                *
'*                                                                *
'* The values returned to the BAX work area by the called program *
'* are separated from each other by single blanks.  Each returned *
'* value represents the result of the calculation specified by    *
'* each group of 3 input values.                                  *
'*                                                                *
'* Additional information is available in the file FPCALC.BAS     *
'* which is the source code for FPCALC.EXE.                       *
'*                                                                *
'*                                                                *
'*                                                                *
'******************************************************************
=AAAA
%BAXSEG = WORKAREA 256 'SEGMENT OF BAX WORK AREA
'
' THE NEXT STATEMENT CALLS FPCALC.EXE.  AFTER ALL NORMAL ARGUMENTS
' HAVE BEEN SPECIFIED, THE BAX WORK AREA INFORMATION IS APPENDED TO
' THE COMMAND STRING AS A FINAL ARGUMENT.
'
%RC = DOS FPCALC S 24.28 13.14 E 20.00 2.000 D 3.4 2 %BAXSEG
'
%FPRESULTS = WORKGET 1 80 'RETRIEVE VALUE WRITTEN TO THE BAX WORK AREA
'                         'BY FPCALC.EXE
'
OUTPUT %FPRESULTS    'DISPLAY RESULTS ON SCREEN SO WE KNOW IT WORKED
'
IF %RC <> 0 THEN OUTPUT RETURN CODE = %RC 'DISPLAY NON-ZERO RETURN CODE
END
:SKIPBAX
