@ECHO OFF
:START
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program is of the "program launcher" genre.  It shows the *
'* technique for selecting a program to run by using BAX but the  *
'* program is actually executed by BAX's underlying batch file.   *
'* The command to be executed and any associated arguments are    *
'* written to an environment variable which is retrieved by the   *
'* underlying batch file after the BAX program has terminated.    *
'* The memory occupied by BAX (usually about 70K) is released     *
'* back into the DOS memory pool and is available to the program  *
'* which is executed by the underlying batch file.                *
'*                                                                *
'* This technique (unlike the one in MAXMEM1.BAT) should work     *
'* with all versions of DOS 3.0 and above, since it does not need *
'* the batch file CALL statement which became available with      *
'* DOS 3.3, unless of course the programs which you are executing *
'* are actually batch files themselves.  If this is the case,     *
'* then the CALL statement is still necessary to effect a return  *
'* to the underlying batch file, which is necessary for this      *
'* program to function as designed.  If you have a version of DOS *
'* prior to 3.3, you can probably get the same results by using   *
'* COMMAND instead of CALL (see your DOS manual for syntax).      *
'* See the program MAXMEM1.BAT for an alternate method of freeing *
'* up memory for use by a called program.                         *
'*                                                                *
'******************************************************************
=maxmem2        ' LOWER CASE LABEL MEANS ALLOW MIXED CASE INPUT
CALL =COLORSUB  ' SET UP COLOR NAMES
%RC = 1         ' STANDARD RETURN CODE (ERRORLEVEL)
'
%P1 = PROGRAM1  ' PROGRAM NAMES
%P2 = PROGRAM2
%P3 = PROGRAM3
'
%S1 = LIT *****************************************************
%S2 = LIT *            SELECT A PROGRAM BY NUMBER             *
%S3 = LIT *                                                   *
%S4 = LIT *                1 --                               *
%S5 = LIT *                2 --                               *
%S6 = LIT *                3 --                               *
%S7 = LIT *                                                   *
%S8 = LIT *            ALL OTHER KEYS RETURN TO DOS           *
%S9 = LIT *****************************************************
'
%S4 = OVERLAY %S4 %P1 23             ' PUT PROGRAM NAMES IN BOX
%S5 = OVERLAY %S5 %P2 23
%S6 = OVERLAY %S6 %P3 23
'
COLORS %BLACK %RED                   ' USE A RED BACKGROUND
CLS                                  ' PAINT THE SCREEN RED
COLORS %YELLOW %BROWN                ' YELLOW ON BROWN FOR BOX COLOR
%X = 0                               ' SET LOOP COUNTER
LOOP =BOTBOX                         ' TOP OF LOOP TO DRAW BOX
%X = ADD %X 1                        ' INCREMENT COUNTER
IF %X > 9 THEN LEAVE =BOTBOX         ' BREAK LOOP
CURSORVH 0 15                        ' POSITION CURSOR IN COLUMN 15
OUTMSG %S%X                          ' DISPLAY TEXT ON SCREEN
OUTPUT                               ' MOVE CURSOR DOWN ONE LINE
=BOTBOX                              ' BOTTOM OF LOOP
OUTPUT                               ' DISPLAY BLANK LINE (COSMETIC)
'
CURSORVH 0 15                        ' POSITION CURSOR AT COLUMN 15
OUTMSG PROGRAM NUMBER ->             ' OUTPUT OUR MESSAGE
%K = INPUTK                          ' GET A KEYSTROKE
IF %K < 49 THEN GOTO =DONE           ' LESS THAN 1, TERMINATE
IF %K > 51 THEN GOTO =DONE           ' MORE THAN 3, TERMINATE
%K = SUB %K 48                       ' RESOLVE KEY VALUE TO 1,2 OR 3
'
OUTPUT                               ' MOVE CURSOR TO NEXT LINE
OUTPUT                               ' GO ONE MORE
COLORS %YELLOW %MAGENTA              ' SET COLORS FOR ARGUMENT PROMPT
OUTMSG ARGUMENTS FOR %P%K ->         ' OUTPUT THE PROMPT MSG
%ARGS = %N                           ' NULL STRING, LET BAX FIGURE LENGTH
COLORS %WHITEX %BLUE                 ' COLORS FOR INPUT AREA
INPUT %ARGS                          ' GET THE ARGUMENT LIST
OUTPUT                               ' MOVE CURSOR TO NEXT LINE
COLORS %YELLOW %BROWN                ' RETURN TO ORIGINAL COLOR SCHEME
%MM = JOIN %P%K %B %ARGS             ' PROGRAM NAME AND ARGS = SINGLE VAR
'
'NOTE: IF PROGRAM IS A BATCH FILE, USE: %MM = JOIN CALL %P%K %B %ARGS
'
ENVSET P MM %MM                      ' SET ENV VAR MM IN PARENT ENV
%RC = 0                              ' SET ERRORLEVEL FOR BATCH FILE
=DONE
OUTPUT                               ' COSMETIC BLANK LINE
STOP %RC                             ' TERMINATE WITH ERRORLEVEL
'
=COLORSUB         ' SUB-ROUTINE TO ASSIGN MEANINGFUL NAMES TO COLORS
'
%BLACK    =  0    ' NOTE: IF YOU ADD 8 TO ANY OF THESE YOU
%BLUE     =  1    ' WILL GET THE SAME COLOR, ONLY BRIGHTER.
%GREEN    =  2
%CYAN     =  3
%RED      =  4
%MAGENTA  =  5
%BROWN    =  6
%WHITE    =  7
'                  **** BRIGHTER COLORS ****
%GRAY     =  8     ' A BRIGHT BLACK IS GRAY
%BLUEX    =  9
%GREENX   = 10     ' BRIGHT COLORS MAY ONLY BE USED IN THE FOREGROUND
%CYANX    = 11
%REDX     = 12
%MAGENTAX = 13
%YELLOW   = 14     ' A BRIGHT BROWN IS YELLOW
%WHITEX   = 15
'
RETURN
END
'
'******************************************************************
'* When our bax program terminates, control is passed to the      *
'* batch file :SKIPBAX label.  If we terminated with a return     *
'* code (errorlevel) of 1, it means that we did not write an      *
'* environment variable with a command to be executed in our      *
'* parent's environment.                                          *
'* If we terminated with a return code of zero, it tells our      *
'* batch file that we did write an environment variable in our    *
'* parent's environment.  Our underlying batch file can then      *
'* retrieve this environment variable and use it to execute the   *
'* program which needs to be executed (in this case %MM%).        *
'*                                                                *
'* In this case our underlying batch file does this, and then     *
'* uses the DOS SET command to erase the variable once control    *
'* returns into our underlying batch file.  This is not strictly  *
'* necessary, but it never hurts to "tidy up" a bit.              *
'*                                                                *
'* Notice that in this program, unlike MAXMEM1.BAT, instead of    *
'* simply terminating after executing the required command, we    *
'* branch to the batch file label "start" which is located just   *
'* before the call to BAX at the top of this file.  This places   *
'* the entire BAX program inside a batch file loop, so after each *
'* command is executed, our underlying batch file runs our BAX    *
'* program again.  This will continue until the underlying batch  *
'* file receives an errorlevel of 1 from the BAX program.         *
'*                                                                *
'* Unfortunately, this will not work if we can't get control back *
'* from the executing program, so if the executing program is a   *
'* batch file, be sure to use the batch file CALL statement if it *
'* is available (DOS 3.3 or above) or the DOS COMMAND command if  *
'* you are using a version of DOS prior to 3.3.                   *
'******************************************************************
'
:SKIPBAX
IF ERRORLEVEL 1 GOTO NOMORE
CLS
%MM%
SET MM=
GOTO START
:NOMORE
