@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'
'******************************************************************
'* This program shows the technique for passing the name of a     *
'* variable to a sub-routine, which will be used by the sub-      *
'* routine to return a value to the main program.  In this sample *
'* program, all we did was take the date information returned by  *
'* the NOW function and convert it to a more standard format for  *
'* display purposes.  This is a trivial task and could be done in *
'* any number of ways, but the thing that may not be completely   *
'* obvious from reading the BAX documentation is that not only    *
'* can you use the CALL statement to pass values to sub-routines, *
'* but you can also pass the name(s) of one or more variables.    *
'* In this simple example, we passed the name of one variable to  *
'* be set by the sub-routine (MDY).  The "trick" to doing this    *
'* is to pass the variable name as a constant, omitting the %     *
'* sign which normally appears as a variable name prefix.  In     *
'* this case the constant MDY is assigned to the variable %XXX,   *
'* which is then used as a double variable on the line just prior *
'* to the sub-routine's RETURN statement.  Notice the double      *
'* per cent sign at the beginning of this statement.  "%XXX" is   *
'* replaced by the characters "MDY", making the word to the left  *
'* of the equal sign "%MDY", a standard variable name which is    *
'* assigned the date formatted as MM/DD/YY.                       *
'*                                                                *
'* This feature allows you to create sub-routines which are       *
'* functionally equivalent to functions which return value(s) in  *
'* the variable(s) of your choice.                                *
'*                                                                *
'******************************************************************
'
=AAAA
CALL =FORMDATE MDY               'CALL DATE FORMATTING SUB-ROUTINE
'
OUTPUT FORMATTED DATE IS: %MDY   'SHOW THAT THE SUB-ROUTINE WORKED
STOP                             'TERMINATE EXECUTION
'
=FORMDATE %XXX                   'DATE FORMATTING SUB-ROUTINE
%FD1 = NOW                       'GET DATE AND TIME
%YY = MID %FD1 3 2               'YEAR
%MM = MID %FD1 6 2               'MONTH
%DD = MID %FD1 9 2               'DAY
%%XXX = JOIN %MM / %DD / %YY     'STANDARD DATE:     MM/DD/YY
RETURN                           'RETURN TO MAIN PROGRAM
'
END                              'END OF BAX PROGRAM
:SKIPBAX
