@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* THIS PROGRAM DEMONSTRATES THE TECHNIQUE FOR CALLING AN         *
'* EXTERNAL SUBROUTINE, WHICH IS SIMPLY ANOTHER BAX PROGRAM.      *
'* EXTERNAL SUBROUTINES SHOULD BE CALLED WITH THE EXECOM FUNCTION *
'* SO THAT CHARACTER STRINGS AS WELL AS AN ERRORLEVEL CAN BE      *
'* RETURNED TO THE CALLING PROGRAM.  THIS IS DONE, AS SHOWN       *
'* BELOW BY RETRIEVING AN ENVIRONMENT VARIABLE WRITTEN BY THE     *
'* CALLED (CHILD) PROGRAM ON THE CALLER'S ENVIRONMENT.  THE       *
'* VARIABLE %EXITKEY IS THE ERRORLEVEL RETURNED BY THE CALLED     *
'* PROGRAM (INPUTSUB.BAX).  THE VARIABLE %STRINGRET IS A STRING   *
'* OF CHARACTERS WRITTEN BY INPUTSUB.BAX ON THIS PROGRAMS'S       *
'* ENVIRONMENT.  TO UNDERSTAND THE PROCESS COMPLETELY, YOU MUST   *
'* ALSO EXAMINE INPUTSUB.BAX.  THE ENVIRONMENT VARIABLE BAXWORK   *
'* IS USED IN THIS CASE TO EFFECT THE DATA TRANSFER, BUT ANY      *
'* ENVIRONMENT VARIABLE NAME CAN BE USED, JUST SO LONG AS THE     *
'* NAME IS KNOWN TO BOTH PROGRAMS INVOLVED.  IN THIS SIMPLE       *
'* EXAMPLE, ONLY ONE VALUE IS TRANSFERRED THIS WAY, BUT YOU COULD *
'* TRANSFER MANY VALUES BY USING MANY VARIABLES.  THE ONE CAVEAT  *
'* HERE IS THAT YOU HAVE TO BE CAREFUL NOT TO OVERFLOW THE        *
'* AVAILABLE ENVIRONMENT SPACE.  BAX PROGRAMS CAN INCREASE THEIR  *
'* ENVIRONMENT SPACE BY 16384 CHARACTERS OVER AND ABOVE THE SPACE *
'* WHICH IS INITIALLY GIVEN TO THEM BY THEIR CALLING PROGRAM,     *
'* WHETHER THAT PROGRAM IS COMMAND.COM OR ANY OTHER. AS A GENERAL *
'* RULE, THIS MUCH ISN'T NECESSARY.  THIS PROGRAM ONLY GETS AN    *
'* EXTRA 256 CHARACTERS WHICH IS MORE THAN ENOUGH FOR INPUTSUB.BAX*
'* TO WRITE THE RETURN VALUE ON.  IN THIS SIMPLE CASE, IT WOULD   *
'* ALSO HAVE WORKED IF WE HAD SIMPLY DELETED ONE OR MORE EXISTING *
'* ENVIRONMENT VARIABLES.  THIS WOULD HAVE FREED UP ENOUGH SPACE  *
'* TO RECEIVE THE SMALL STRING WE ARE EXPECTING TO GET BACK, BUT  *
'* THEN WE HAVE TO CHECK THE LENGTHS OF THE VARIABLES WE ARE      *
'* DELETING TO MAKE SURE WE ARE CREATING ENOUGH FREE SPACE, AND   *
'* WE ALSO NEED TO KNOW IF THE PROGRAM WE ARE CALLING NEEDS SOME  *
'* OR ALL OF THEM.  SIMPLY GETTING EXTRA SPACE IS MUCH EASIER.    *
'******************************************************************
=aaa                                    ' ALLOW MIXED CASE DATA
CLS                                     ' CLEAR SCREEN
%S = ENVSIZE 256                        ' GET EXTRA ENVIRONMENT SPACE
%P = ENVGET C PATH                      ' GET DOS PATH VARIABLE
%PROG = PATHFIND BAX.EXE %P             ' GET FULL FILESPEC FOR BAX.EXE
%EXITKEY = EXECOM %PROG INPUTSUB.BAX    ' CALL EXTERNAL SUB-ROUTINE
%STRINGRET = ENVGET C BAXWORK           ' RETRIEVE INPUT STRING
CURSORVH 22 1                           ' MOVE OUT OF INPUTSUB'S BOX
'
IF %EXITKEY = 0 THEN %K = ENTER ELSE %K = ESCAPE
'
OUTPUT EDITING WAS TERMINATED BY PRESSING THE %K KEY
OUTPUT THE STRING VALUE RETURNED WAS: %STRINGRET
'
END
'******************************************************************
'* OUR WORKING ENVIRONMENT(S) GO AWAY ONCE OUR PROGRAMS HAVE      *
'* COMPLETED EXECUTION AND CONTROL HAS RETURNED TO COMMAND.COM.   *
'* COMMAND.COM'S ENVIRONMENT IS NOT CHANGED IN ANY WAY.           *
'*                                                                *
'******************************************************************
:SKIPBAX
