@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program demonstrates the use of the DIRX.EXE utility      *
'* program.  DIRX writes directory information on a file which    *
'* can then be opened and read by a BAX program.  The primary     *
'* advantage to using DIRX rather than the internal BAX routines  *
'* FILELIST -- FILENAME -- FILEDATA is that DIRX can handle       *
'* directories with up to 3000 files in them.  Directories that   *
'* large will almost certainly cause memory problems if you try   *
'* to process them using BAX's internal functions.  Another       *
'* advantage to using DIRX is that you can use the attribute byte *
'* to get information about files which might not show up in the  *
'* list generated by BAX's FILELIST statement.  Directories,      *
'* volume label, etc.  DIRX sorts the output records by filename, *
'* and also displays the attribute byte in both decimal and       *
'* binary format; two more niceties that you don't get if you use *
'* BAX's internal facilities.                                     *
'*                                                                *
'* The BAX EXECOM function was used to call DIRX.EXE in this      *
'* program but it could have been called with CMD or DOS.  See    *
'* the file DIRX.DOC for full details on using DIRX.EXE.          *
'*                                                                *
'* This program displays all files in the current directory with  *
'* BAT, COM or EXE extensions.  It could be modified to select    *
'* files according to much more complex selection criteria, and   *
'* of course what is done with the files selected is up to the    *
'* programmer. In a demonstration program, not much can be        *
'* done except display things, but the selected files could be    *
'* deleted, renamed, moved to other directories, etc.             *
'*                                                                *
'* The extensions to test for are "hard coded" in this program,   *
'* but typically, in a program of this type, they would be        *
'* entered as command line arguments or selected from a menu.     *
'******************************************************************
=AAA                                   'MUST BEGIN WITH A LABEL
%A1 = .COM                             'EXTENSION 1
%A2 = .EXE                             'EXTENSION 2
%A3 = .BAT                             'EXTENSION 3
%WORKFILE = DIRX.XXX                   'WORKFILE NAME (COULD BE ANYTHING)
%X = EXECOM DIRX.EXE *.* 0 %WORKFILE   'CALL DIRX PROGRAM TO WRITE FILE
IF %X = 0 THEN GOTO =ONWARD            'GOOD RETURN CODE, CONTINUE
OUTPUT SORRY, NO FILES FOUND           'NO FILES MATCH SELECTION CRITERIA
STOP %X                                'TERMINATE
=ONWARD                                'WE BRANCH HERE IF WE HAVE FILES
OPENIN %WORKFILE                       'OPEN THE WORKFILE
LOOP =FFF                              'TOP OF LOOP
INPUTF %RECORD                         'READ A RECORD FROM THE FILE
IF %EOF > 0 THEN LEAVE =FFF            'BREAK LOOP WHEN THERE ARE NO MORE
%FN = LEFT %RECORD 12                  'FILENAME IS FIRST 12 CHARS
%FN = TRIMR %FN                        'REMOVE TRAILING BLANKS
%FEXT = RIGHT %FN 4                    'USE LAST FOUR AS EXTENSION
'
%TVAL = TEST %FEXT = %A1 %FEXT = %A2 %FEXT = %A3 'TEST FOR COM,EXE,BAT
'
IF %TVAL > 0 THEN OUTPUT %RECORD       'TEST IS TRUE, SO DISPLAY RECORD
=FFF                                   'LOOP BACK AND DO ANOTHER ONE
CLOSEIN                                'CLOSE WORK FILE
DELETE %WORKFILE                       'TRASH IT
END                                    'TERMINATE OUR BAX PROGRAM
:SKIPBAX
